/*
 * Element class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util.resource.hierarchy;

import java.util.Collections;
import java.util.Enumeration;
import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.LinkedHashMap;

/**
 * 階層構造を持つ要素クラス。 
 *
 * @author  佐藤隆之. 
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:50 $
 */
public class Element
{
  /** 要素名。 */
  private String name_ ;

  /** 要素の値。 */
  private String value_ = null;

  /** 属性マップ。*/
  private AttributeMap attrMap_ = new AttributeMap();

  /** 親要素。 */
  private Element parent_ = null;

  /** 子要素を格納するマップ。*/
  Map<String, List<Element>> childMap_ =
    new LinkedHashMap<String, List<Element>>();

  /**
   * ルート要素を作成する。
   * <br>
   * ルート要素は、リソースを構成する要素のトップに位置する要素のことを言い、
   * 要素名も要素値も空、属性は持たず、子要素の数は1つだけという特徴をもつ。
   *
   * @return 作成されたルート要素。
   */
  public static Element createRootElement()
  {
    return new Element() {
        @Override public String setValue(String value) {
          assert false;
          return "";
        }
        @Override public String putAttribute(String name, String value) {
          assert false;
          return "";
        }
      };
  }

  /**
   * デフォルトコンストラクタ。
   */
  private Element()
  {
    name_ = "";
    parent_ = null;
  }

  /**
   * 要素名を引数にもつコンストラクタ。
   * 
   * @param  name 要素名。
   * @throws AssertionError 要素名がヌル又は空文字列の場合。
   */
  public Element(String name)
  {
    assert (name != null) : "@param:name is null.";
    assert (name.length() > 0) : "@param:name is empty.";

    name_ = name;
  }

  /**
   * 要素名を取得する。
   *
   * @return 要素名。
   */
  public String getName()
  {
    return name_ ;
  }

  /**
   * 要素の値を取得する。
   *
   * @return 要素の値。
   */
  public String getValue()
  {
    return value_ ;
  }

  /**
   * 要素の値を設定する。
   * <br>
   * 引数がヌルの場合は、そのままヌルを設定する。
   *
   * @param  value 要素の値。
   * @return 前回の要素値。
   */
  public String setValue(String value)
  {
    String oldValue = value_ ;
    value_ = value;
    return oldValue;
  }

  /**
   * 親要素を取得する。
   *
   * @return  親要素。
   */
  public Element getParent()
  {
    return parent_ ;
  }

  /**
   * この要素の属性を格納したマップを取得する。
   *
   * @return この要素の属性を格納したマップ。
   */
  public AttributeMap getAttributes()
  {
    return attrMap_ ;
  }

  /**
   * 属性を設定する。
   *
   * @param  name 属性名。
   * @param  value 属性値。
   * @return  前回の属性値。
   * @throws  AssertionError 引数がヌル又は属性名が空文字列の場合。
   */
  public String putAttribute(String name, String value)
  {
    assert (name != null) : "@param;name is null.";
    assert (value != null) : "@param:value is null";
    assert (name.length() > 0) : "@param:name is empty";

    return attrMap_.put(name, value);
  }

  /**
   * 子要素を追加する。
   *
   * @param  child 子要素。
   * @throws AssertionError 引数がヌルの場合。
   */
  public void addChild(Element child)
  {
    assert (child != null) : "@param:child is null.";

    List<Element> eL = childMap_.get(child.getName());
    if (eL == null) {
      eL = new LinkedList<Element>();
      childMap_.put(child.getName(), eL);
    }
    child.parent_ = this;
    eL.add(child);
  }

  /**
   * 指定された要素名を持つ全ての子要素を削除する。
   *
   * @param  name 要素名。
   * @throws AssertionError 引数がヌルの場合。
   */
  public void removeChildren(String name)
  {
    assert (name != null) : "@param:name is null.";

    childMap_.remove(name);
  }

  /**
   * この要素の全ての子要素を削除する。
   */
  public void removeAllChildren()
  {
    childMap_.clear();
  }

  /**
   * 指定された要素名をもつ最初の子要素を取得する。
   * <br>
   * 指定された要素名をもつ子要素が一つも存在しない場合はヌルを返す。
   *
   * @param  name 要素名。
   * @return 指定された要素名をもつ最初の子要素。
   * @throws AssertionError 引数がヌルの場合。
   */
  public Element getFirstChild(String name)
  {
    assert (name != null) : "@param:name is null.";

    List<Element> eL = childMap_.get(name);
    if (eL == null || eL.size() == 0) {
      return null;
    }
    return eL.get(0);
  }

  /**
   * 指定された要素名を持つ全ての子要素を格納したリストを取得する。
   * <br>
   * 指定された要素名を持つ子要素が一つも存在しない場合は空のリストを返す。
   *
   * @param  name 要素名。
   * @return 指定された要素名を持つ全ての子要素を格納したリスト。
   * @throws AssertionError 引数がヌルの場合。
   */
  public List<Element> getChildren(String name)
  {
     assert (name != null) : "@param:name is null.";

     List<Element> eL = childMap_.get(name);
     return (eL != null) ? eL : new LinkedList<Element>();
  }

  /**
   * この要素の全ての子要素を列挙する。
   *
   * @return 全ての子要素を格納した列挙オブジェクト。
   */
  public List<Element> getAllChildren()
  {
    List<Element> allL = new LinkedList<Element>();
    for (List<Element> eL : childMap_.values()) {
      for (Element e : eL) {
        allL.add(e);
      }
    }
    return allL;
  }
}
